
		'MORSE CODE IN PROTON BASIC BY MARK RODGERS G0EBB. 13,02,04
		'mark@rodgers.fsworld.co.uk
		
		'This version is for use with an LCD.
		
		'This idea has been done many times before, but not by me.
		'I do not think any part of this code is the same as anyone elses.
		
		'It is presented as is with no guarantees or responsibilities implied.
		'It is not for any comercial use(I wish!) or to copy and pass any part as
		'your own, I would be happy if it was used to develop your own comercial free 
		'code or as the basis for a club project with inclusion of author recognition.
		'Please feel free to contact me if you wish to use this code/hardware for any reason.
		
'------------------------------------------------------------------------------------------------
		
		'version notes.
		
		'This version reads the key input and displays the code on screen. All morse characters are
		'catered for and some punctuation etc. The details of the characters and conventions of morse
		'are detailed in "morse.txt" which is part of this package. The code has been much reduced
		'from the prototypes due to too many error trapping routines. I have found if you send bad
		'morse it will display bad morse!. If you try it you will find that the pic is often better than you!
		'NOTE: the key contacts must be clean as it is easy to get bad characters because of dirty contacts.
		'Version "LCD_morse_1.bas"
		
'------------------------------------------------------------------------------------------------

		'This program was written to see if I could work out the idea of reading morse code using a pic.
		'I have not looked at any other program or used any others work, It was done as an exersise in
		'learning how to break down a problem into sections and deal with them in order.
		'I have no formal knowledge of programming(did you guess?) and have come from the Sinclair
		'school of learning.
		'I have for many years been very envious of people who could be bothered to write programs in assembler.
		'I totally glaze over at that thought, but if it is Basic! then it is a different kettle of fish.
		'Proton lets me be creative with software(I am competent with hardware)in a way that was not possible before.
		'So now I am doing things I have always wished I could achieve without falling asleep at the mention of
		'MOVWF or some other boring 5 letter nonsense.
		'This is a very "Basic" program with many flaws but I will change it to have auto baud reading and memories etc.
		'As it stands it will work well with a good fist, ie. if you send good morse it will read it!
 
'------------------------------------------------------------------------------------------------
		
		'MY TEST SYSTEM USES AN 18F452 AT 20MHZ, AS THE TIMING FOR THIS PROGRAM RELIES ON LOOP
		'COUNTING TO DECODE THE CHARACTERS, WITH OTHER CRYSTAL FREQUENCYS THE "letter_space" AND
		'"word_space" VARIABLES WILL NEED TO BE CHANGED TO GIVE THE CORRECT DELAYS, REDUCE THEIR
		'VALUE FOR SLOWER FREQUENCYS BUT KEEP THE RATIO.
		
'------------------------------------------------------------------------------------------------	

'------------------------------------------------------------------------------------------------
		
		'use your own LCD setup file here,the one below is for my own Development Board
		'****************************************************************************************
		Device 18F452				'better than an OC71
					
       	XTAL 20						'20 million wiggles per second
		
		lcd_dtpin portd.4
		lcd_enpin porte.0
		lcd_rspin portc.0
		
		bootloader=off	 			'I do not use a bootloader
		
		adcon1=7   	   	  			'set ports to digital
		'****************************************************************************************
		
		dim dit_dah as word			'loop counter used to select "dit"-"dah" elements.
		dim spacing as word		 	'variable used for element and character spacing
		dim letter_space as word	'if "spacing" = "letter_space" value then read next character in word.
		dim word_space as word		'if "spacing" = "word_space" value then read new word.
		dim morse_character			'variable used to store morse "elements".
		dim morse_length			'how many elements have been stored in "morse_character". 
		dim character_bit			'the bit position of "dit" to be stored in "morse_character".
		dim dit as bit	  	 		'if "dit" is 0 then the element is a "dit", if 1 then it is a "dah"
		dim character				'holds the decoded morse "character".
		dim index					'holds the "character" position in the lookup table
		dim x_pos					'screen X position.
		dim y_pos					'screen Y position
		dim plus					'state of "key" when it is pressed
		dim minus					'state of "key" when not pressed
       	

		clear	 	  	   	  	 	'clear all variables(set to 0)					
		
		trisc.1=1					'I am using portc.1 as input, you can change this to any port.
		symbol key=portc.1			'variable "key" is aliased to portc.1.(the key connects between +5v
			   						'and this pin, the port pin connects to ground via a 1k resistor)
		
		
		
		plus=1						 'this program uses a normally low input, ie. when the key is pressed the pin goes high.
									 '"plus=1" and "minus=0" is the setup to achieve this.
		minus=0						 'if you want to change this to use the pullups on portb, for example,
									 'you would change the variables to:"plus=0" and "minus=1".
		
		
									 'THESE VALUES SHOULD WORK ON 6 TO 15 WORDS PER MINUTE.
		letter_space=700			 'this is the loop counter value used to set the time between elements of a character.
									 'if this value is lower you need to send the morse faster!.
		word_space=2500				 'this is the loop counter value if reached tells the routine the word has
									 'been completed and a space needs to be printed after the character. 
		
		cls
		Print at 1,1,"Morse reader by",at 2,1,"M Rodgers G0EBB":delayms 2000
		
set_screen:		
		x_pos=1						 'initialise the LCD
		y_pos=1
		cls		   					 'make sure display is clear
		delayms 200					 'and it is settled
		
'------------------------------------------------------------------------------------------------

'------------------------------------------------------------------------------------------------
start_loop: 	
		spacing=0
		dit_dah=0
		character_bit=0
		
		if key=plus then goto count_morse		'if the key is pressed then jump to count_morse routine
		
		goto start_loop
		
'------------------------------------------------------------------------------------------------

'------------------------------------------------------------------------------------------------
			'This routine waits for a keypress then starts a loop counter "dit_dah".
			'when the key is let go; loop counter "dit_dah" has a value:
			'if 500 or lower then the character is a "dit";(dit=0).
			'if it is between 650 and 2000 it is a "dah";(dit=1).
			'if it is greater than 500 but less than 650 it will print "error" and restart.
			'if it is greater than 3000 the screen is cleared, the routine is ended and the program is restarted.
			
count_morse:
			if key=plus then inc dit_dah		   	  		    'if key is held down then start to count
			if dit_dah=3000 then dit_dah=0:goto set_screen	    'if key is held down too long then clear screen
			
			delayus 250			 	  							'slow things down a little
			
'************ if "dit"=0 then character is a dit, if "dit"=1 then character is a dah ************
			
			if key=minus then select dit_dah		  'when the key has been let go, and if dit_dah...  
		   	  
           	   case <=500 		 					  '...is less than or equal to 500
			   dit=0 				  				  'we have a "dit"(dit=0)
			   gosub make_code
			   dit=0
			   'dit_dah=0
			   goto space_loop
            
           	   case 650 to 2000	 	   				  '...is between 650 and 2000
			   dit=1 				  				  'we have a "dah"(dit=1)
			   gosub make_code
			   dit=0
			   'dit_dah=0
			   goto space_loop
			   
			   case >500,<650,>2000,<3000 			  'if value is between "dit" and "dah"
			   morse_length=6						  'or between word_length and clear screen length
			   gosub print_morse_character			  'then print "error" message
			   dit_dah=0
			   goto count_morse
            
    	    endselect 
			
			goto count_morse
			
'------------------------------------------------------------------------------------------------
		   
'------------------------------------------------------------------------------------------------		


space_loop:				
			'if loop is waiting until word_space is reached then print space now and restart or
			'lose the next character while waiting for spacing to reach word_space value.
			if key=plus and dit_dah=0 then character_bit=0:spacing=word_space
			 
			if key=minus then inc spacing			'start to count the size of space between key presses.
			
			delayus 250	  	  						'slow things down a little
		
			
			'if the key is pressed before the length of a character space it must be another element of the character.
			'if so go back to check for it being a dit or a dah!
			if key=plus and spacing<letter_space then spacing=0:inc character_bit:dit_dah=0:goto count_morse
			
			
			'if the key is not pressed before spacing reaches letter_space; the morse character has been
			'made and now needs to be selected from the lookup table for printing on screen.
			if spacing=letter_space and morse_length>=1 then gosub find_morse_character:spacing=0:dit_dah=0
			
			
			'if the "spacing" reaches the "word_space" value then current printed word is finished;
			'so print a space(ascii 32) on screen and restart.
			if spacing=word_space then character=32:gosub print_morse_character:goto start_loop
			
			
			goto space_loop
			
'------------------------------------------------------------------------------------------------
		   
'------------------------------------------------------------------------------------------------	

'this routine takes the information from "count_morse" and stores it one bit at a time (LSB first)in the variable "morse_character".
'it also stores how many "elements" the character has,ie. letter "K"(_._ or dah,dit,dah) would be;
'"morse_character"= 101(dec 5) and its length is 3 "elements". these two values are then manipulated in the
'"find_morse_character" routine below. this length value is important as the leading zero of characters is ignored
'when passed throught the "find_morse_character" routine; "C"(_._. or dah,dit,dah,dit)is stored in "morse_character"
'as 101(dec 5) because the final element is a "dit" whose value=0 and is ignored in the "find_morse_character" routine.
'you have probably noticed that "K" and "C" have the same value in "morse_character" but they have different lengths
'so when decoded they are located in different places in the table. that caused some headaches!! 
			
make_code:
		   
		   select character_bit
		   		  
				  case <=5										'maximum of six elements to character(0to5)
				  loadbit morse_character,character_bit,dit		'store "dit" and "dah" one bit at a time
				  morse_length=character_bit+1					'I want morse length to be 1 as a minimum
				  
				  case >=6		  			   					'7 or more elements are treated as an error(0to6)
				  gosub print_morse_character					'if an error occurs, skip the decode routine and print
				  												'the message at "print_morse_character"
																'(strictly speaking 8 dits are an error,I have ignored that here)
				  spacing=0										'clear variables.
				  character_bit=0								
				  dit_dah=0
				  morse_character=0
				  morse_length=0
				  goto set_screen								'restart program.
		   
		   endselect
		   
		   return

'------------------------------------------------------------------------------------------------

'------------------------------------------------------------------------------------------------

'this routine decodes "morse_character" thus;
'"K" is morse_character=5, morse_length=3. in order to get a unique address the following is used;
'multiply morse_length by its self (3x3=9) then add the morse_character value(5)(if length of character is less than 4)
'this gives an address of 9+5=14.
'in the example above we found "C" has the same "morse_character" value of 5 as "K", but its length is 4;
'"C" is now 4x4=16, because "C" has 4 elements the value of "morse_character" has one added to become(5+1)=6
'now add 16 and 6=22.
'without the addition of these values to "morse_character" certain values of different "morse_length" and
'"morse_character" produce the same value. 
	   
find_morse_character:
					 
			select morse_length
				   
				   case <4
				   index=morse_length*morse_length
				   index=index+morse_character
				   
				   case 4
				   index=morse_length*morse_length
				   morse_character=morse_character+1
				   index=index+morse_character
				   
				   case 5
				   index=morse_length*morse_length
				   morse_character=morse_character+8
				   index=index+morse_character
				   
				   case 6
				   index=morse_length*morse_length
				   morse_character=morse_character+29
				   index=index+morse_character
				   
			endselect
			
'------------------------------------------------------------------------------------------------

'------------------------------------------------------------------------------------------------

'the index points to the position in the table of the character to be printed, the characters are
'not in consecutive order. 95 is the underscore character and represents an unknown morse character
'34 is the single, double quote(")
			
character_table:		
			character=lookup index,[95,"E","T",95,"I","N","A","M",95,"S","D","R","G","U","K","W",_'0to15
			"O","H","B","L","Z","F","C","P","o","V","X","a","Q","u","Y","J","e","5","6",95,"7",_'16to36
			"e",95,95,"8","w","/","+",95,95,"(",95,"9","4","=","/",95,95,95,95,95,"3",95,95,"~","2",95,"1",_'37to63
			"0",95,95,95,95,95,95,95,";",95,95,95,95,"?",95,95,95,95,95,34,95,95,95,95,95,95,95,_'64to90
			95,95,95,95,"'",95,95,"-",95,95,95,95,95,95,95,95,".",95,"!",")",95,95,95,95,95,","]'91to116
			
			
print_morse_character:		
			if character>0 then print at y_pos,x_pos,character		 'only print if "character" has a value.
			
			if character_bit>=6 then print at y_pos,1,"ERROR           ":delayms 1000:return    'only print if an error has occured.
			
			select y_pos	   		 	   	  					       	 'scroll screen until it reaches bottom, then clear and restart.
						
				   case 1										      	 'if line 1 is in use
				   inc x_pos  									      	 'move the character one position right.
				   if x_pos=16 then y_pos=2:x_pos=1:goto clear_variables 'if the edge of the screen is reached, return to left.
				   
				   case 2	   									      	 'if line 2 is in use
				   inc x_pos										 'move the character one position right.
				   if x_pos=16 then goto set_screen		          	 'if character reaches bottom right of screen, clear and restart.
				   				   
			endselect
			
clear_variables:					 							      	 'reset varaiables for another character!
			morse_character=0
			morse_length=0
			index=0
			character_bit=0
			dit=0
			return
			
'------------------------------------------------------------------------------------------------

'------------------------------------------------------------------------------------------------   
		
		end